#define _sizeOfX 1e7

class A
  {
private:
   void fill();
public:
   long x[];
        A() { fill(); };
  };

void A::fill(void)
  {
   MathSrand(GetTickCount());
   ArrayResize(x, _sizeOfX);
   for(int i = _sizeOfX - 1; i >= 0; i--)
      x[i] = MathRand() % 100;
  }

#define _methodBody(arr)                  \
   long result = 0;                       \
   for(int i = _sizeOfX - 1; i >= 0; i--) \
      result += arr[i];                   \
   return(result);

class B
  {
public:
   long withPtr()             { _methodBody(m_a.x) }
   long withRef(const A& obj) { _methodBody(obj.x) }
   long testWithPtr();
   long testWithRef();
public:
   void test();
private:
   const A*const m_a;
public:
         B(A* ptr) : m_a(ptr) {}
  };

void OnStart()
  {
   A *a = new A();
   B b(a);
   b.test();
   delete a;
  }

void B::test()
  {
   long sum1 = testWithPtr();
   long sum2 = testWithRef();
   Print("Do the sums mutch: ", sum1 == sum2 ? "true" : "false", " (", sum1, ")");
  }

long B::testWithRef()
  {
   const ulong StartTime = GetMicrosecondCount();
   long result = withRef(m_a);
   Print(__FUNCTION__": ", (string)(GetMicrosecondCount() - StartTime));
   return(result);
  }

long B::testWithPtr()
  {
   const ulong StartTime = GetMicrosecondCount();
   long result = withPtr();
   Print(__FUNCTION__": ", (string)(GetMicrosecondCount() - StartTime));
   return(result);
  }